library CurioAddIn;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

uses
  SysUtils,
  Classes,
  Interfaces,
  Forms,
  acuObject,
  utuMessage,
  acuRepositorySQL,
  acuSQLDialectManager,
  acuSQLDialectSQLServer,
  acuSQLDialectOracle,
  acuSQLDialectDB2,
  acuFramework,
  acuQuerySQLODBC,
  ituExplorerV2,
  IntegracaoDelphiSUML in 'IntegracaoDelphiSUML.pas',
  Mostra_Processamento in 'Mostra_Processamento.pas' {FMostra_Processamento},
  InstantClasses in 'InstantCode\InstantClasses.pas',
  InstantCode in 'InstantCode\InstantCode.pas',
  InstantTextFiler in 'InstantCode\InstantTextFiler.pas',
  Utility in 'Utility.pas',
  utuOQL in 'utuOQL.pas',
  utuXSD in 'utuXSD.pas',
  DelphiAddInObj in 'DelphiAddInObj.pas';

exports
  InitializeAddIn,
  FinalizeAddIn,
  DoMenuAction;

{$R *.res}

begin

  ChangeLocaleFormatSetting;
  gDefaultDatabaseDriver := typeOf(acDatabaseSQLODBC);
  PersistenceManager.DefaultRepositoryClass := typeOf(acRepositorySQL);
  PersistenceManager.RegisterClass(typeOf(acPersistentObject), acPersistentObjectClassFactory.Create);
  gSQLDialectManager.RegisterSQLDialect('MS SQL Server', typeOf(acSQLDialectSQLServer), acSQLDialectSQLServerClassFactory.Create);
  gSQLDialectManager.RegisterSQLDialect('Oracle', typeOf(acSQLDialectOracle), acSQLDialectOracleClassFactory.Create);
  gSQLDialectManager.RegisterSQLDialect('DB2', typeOf(acSQLDialectDB2), acSQLDialectDB2ClassFactory.Create);

  Application.Initialize;
//  ExtensionManager.LoadProfiles;
//  StarUMLApplication.OpenProject('D:\Users\sandrosantana\Documents\git\GED\mdl\GED.uml');
//  Application.CreateForm(TExplorerV2, ExplorerV2);
//  Application.Run;
end.
