unit ituDataBaseLogin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids, ValEdit, Registry, Buttons, RTTICtrls,
  IntegracaoDelphiSUML, acuSQLDialectManager;

const cPROJECT_SAVE_OPTIONS_PATH = 'Software\StarUML\Options\' + cOPTIONSCHEMAID + '\Projects\';

type

  { TDataBaseLogin }

  TDataBaseLogin = class(TForm)
    Bevel1: TBevel;
    Bevel2: TBevel;
    Button1: TButton;
    Button2: TButton;
    cbODBCD_DSN: TComboBox;
    cbDialect: TComboBox;
    cbODBCD_DRIVERS: TComboBox;
    edtServerName: TLabeledEdit;
    edtUsuario: TLabeledEdit;
    edtPassword: TLabeledEdit;
    edtDatabaseName: TLabeledEdit;
    Label2: TLabel;
    rbDSN: TRadioButton;
    rbPersonalizado: TRadioButton;
    procedure cbODBCD_DSNChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure rbDSNClick(Sender: TObject);
    procedure rbPersonalizadoClick(Sender: TObject);
  private
    FProjectFileName: string;
    procedure SetProjectFileName(const Value: string);
  public
    property ProjectFileName: string read FProjectFileName write SetProjectFileName;
  end;

implementation

uses acuQuerySQLODBC, strUtils, acuObject, utuFactory;

{$R *.dfm}

procedure TDataBaseLogin.Button2Click(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TDataBaseLogin.Button1Click(Sender: TObject);
var lReg: TRegistry;
begin
  ModalResult := mrNone;
  if (cbODBCD_DSN.ItemIndex <> -1) and (cbDialect.ItemIndex <> -1) then
  begin
    lReg := TRegistry.Create;
    try
      lReg.RootKey := HKEY_CURRENT_USER;
      lReg.OpenKey(cPROJECT_SAVE_OPTIONS_PATH + ProjectFileName + '\Explorer', true);
      lReg.WriteString('DEFAULT_DSN', cbODBCD_DSN.Caption);
      lReg.WriteString('DEFAULT_DRIVER', cbODBCD_DRIVERS.Caption);
      lReg.WriteString('DEFAULT_SERVER', edtServerName.Text);
      lReg.WriteString('DEFAULT_DATABASE', edtServerName.Text);
      lReg.WriteString('DEFAULT_DSN_USER', edtUsuario.Text);
      lReg.WriteString('DEFAULT_SQL_DIALECT', cbDialect.Caption);
    finally
      lReg.free;
    end;
    ModalResult := mrOk;
  end;
end;

procedure TDataBaseLogin.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caHide;
end;

procedure TDataBaseLogin.cbODBCD_DSNChange(Sender: TObject);
begin
  {$IFDEF MSWINDOWS}
//  edtUsuario.Text := GetDSNLastUser(cbODBCD_DSN.Text);
  {$ENDIF}
  edtPassword.Text := '';
end;


procedure TDataBaseLogin.FormShow(Sender: TObject);
var lReg: TRegistry;
    lDSN, lDriver, lDialect: string;
    lObj: acObject;
begin
  GetSystemDSNList(cbODBCD_DSN.Items);
  GetUserDSNList(cbODBCD_DSN.Items);
  GetDriverList(cbODBCD_DRIVERS.Items);

  for lObj in gSQLDialectManager.InstancedObjects do
  begin
    cbDialect.AddItem(acFactoredObject(lObj).Ticket.Code, lObj);
  end;

  ModalResult := mrNone;
  lReg := TRegistry.Create;
  try
    lReg.RootKey := HKEY_CURRENT_USER;
    lReg.OpenKey(cPROJECT_SAVE_OPTIONS_PATH + ProjectFileName + '\Explorer', true);

    lDSN := lReg.ReadString('DEFAULT_DSN');
    if lDSN <> '' then
    begin
      rbDSN.Checked := True;
      rbDSNClick(rbDSN);
      cbODBCD_DSN.ItemIndex := cbODBCD_DSN.Items.IndexOf(lDSN);
    end
    else
    begin
      lDriver := lReg.ReadString('DEFAULT_DRIVER');
      if lDriver <> '' then
      begin
        rbPersonalizado.Checked := True;
        rbPersonalizadoClick(rbPersonalizado);
        edtServerName.Text := lReg.ReadString('DEFAULT_SERVER');
        edtDatabaseName.Text := lReg.ReadString('DEFAULT_DATABASE');
      end;
    end;

    edtUsuario.Text := lReg.ReadString('DEFAULT_DSN_USER');

    lDialect := lReg.ReadString('DEFAULT_SQL_DIALECT');
    if lDialect <> '' then cbDialect.ItemIndex := cbDialect.Items.IndexOf(lDialect);
  finally
    lReg.free;
  end;

  if (cbODBCD_DSN.Caption <> '') and (cbDialect.Caption <> '') and (edtUsuario.Text <> '')
    then edtPassword.SetFocus;
end;

procedure TDataBaseLogin.rbDSNClick(Sender: TObject);
begin
  cbODBCD_DSN.Enabled := True;
  cbODBCD_DRIVERS.Enabled := False;
  edtDatabaseName.Enabled := False;
  edtServerName.Enabled := False;
end;

procedure TDataBaseLogin.rbPersonalizadoClick(Sender: TObject);
begin
  cbODBCD_DSN.Enabled := False;
  cbODBCD_DRIVERS.Enabled := True;
  edtDatabaseName.Enabled := True;
  edtServerName.Enabled := True;
end;

procedure TDataBaseLogin.SetProjectFileName(const Value: string);
begin
  FProjectFileName := Value;
end;


end.
